Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| WebLogic Integration
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.bea.wlpi.server.admin
Interface Admin

public interface Admin
extends javax.ejb.EJBObject

Provides WebLogic Process Integrator administrative functions.

Author:
  Copyright © 2000, 2001 BEA Systems, Inc. All Rights Reserved.
See Also:
  `AdminHome`

Field Summary
`static int` | `TASKCOUNT_COMPLETED` Count of tasks that have completed.
`static int` | `TASKCOUNT_INACTIVE` Count of tasks which have not started yet.
`static int` | `TASKCOUNT_OVERDUE` Count of tasks that have started and their due date has passed.
`static int` | `TASKCOUNT_PENDING` Count of tasks which have started but have not completed.
`static int` | `TASKCOUNT_TOTAL` Count of all tasks assigned to user/role.

Method Summary
`java.lang.String` | `addBusinessCalendar(BusinessCalendarInfo calendarInfo)` Create a new business calendar.
`java.lang.String` | `addBusinessOperation(ClassInvocationDescriptor descriptor)` Create a new business operation implemented by a Java class.
`java.lang.String` | `addBusinessOperation(EJBInvocationDescriptor descriptor)` Create a new business operation implemented by an EJB.
`void` | `addEventKey(EventKeyInfo eventKeyInfo)` Create a new event key.
`java.lang.String` | `addReroute(java.lang.String orgID, java.lang.String from, java.lang.String to, int type, java.sql.Timestamp effective, java.sql.Timestamp expiry)` Create a new task reroute.
`boolean` | `checkForTemplateDefinitionInstances(java.lang.String templateDefinitionID)` Check whether the specified workflow template definition has any instances.
`boolean` | `checkForTemplateInstances(java.lang.String templateID)` Check whether a workflow template has any started instances which are not yet complete.
`java.lang.String` | `createTemplate(java.lang.String name, java.util.Collection orgs)` Deprecated. Use the new `createTemplate(String,String,Collection)` or `createTemplate(String,String,Collection,Object)`
`java.lang.String` | `createTemplate(java.lang.String name, java.lang.String xml, java.util.Collection orgs)` Create a workflow template with the specified name.
`java.lang.String` | `createTemplate(java.lang.String name, java.lang.String xml, java.util.Collection orgs, java.lang.Object requestID)` Create a workflow template with the specified name.
`java.lang.String` | `createTemplateDefinition(java.lang.String templateID, java.lang.String name, java.lang.String xml)` Create a definition for a workflow template, using the name and content supplied.
`java.lang.String` | `createTemplateDefinition(java.lang.String templateId, java.lang.String name, java.lang.String xml, java.lang.Object requestID)` Create a definition for a workflow template, using the name and content supplied.
`void` | `deleteBusinessCalendar(java.lang.String calendarID)` Delete a business calendar.
`void` | `deleteBusinessOperation(java.lang.String busOpID)` Delete a business operation.
`void` | `deleteEventKey(EventKeyInfo eventKeyInfo)` Delete an event key.
`void` | `deleteInstance(java.lang.String instanceID)` Delete a workflow instance.
`void` | `deleteReroute(java.lang.String rerouteID)` Delete a task reroute.
`void` | `deleteTemplate(java.lang.String templateID)` Delete a workflow template.
`void` | `deleteTemplateDefinition(java.lang.String templateDefinitionID)` Delete a workflow template definition.
`void` | `deleteTemplateDefinitionInstances(java.lang.String templateDefinitionID, java.lang.String orgID, boolean bStarted, java.util.Date from, java.util.Date to)` Delete instances of a workflow template definition in an organization.
`void` | `deleteTemplateInstances(java.lang.String templateID, java.lang.String orgID, boolean bStarted, java.util.Date from, java.util.Date to)` Delete instances of a workflow template in an organization.
`byte[]` | `exportPackage(PublishPackage publishPackage, java.lang.Object credential)` Exports a package of workflow objects specified by publishPackage.
`java.lang.String` | `findCallableWorkflow(java.lang.String templateName, java.lang.String templateID, java.lang.String orgID)` Return the most appropriate (active and effective) callable workflow template.
`java.sql.Timestamp` | `findOldestTemplateInstance(java.lang.String templateID)` Find the date and time of the oldest completed instance for this template.
`java.util.List` | `getAllBusinessCalendars(boolean includeDefinition)` List the business calendars defined in the workflow system.
`java.lang.String` | `getBusinessCalendarDefinition(java.lang.String calendarID)` Return the definition of a business calendar.
`java.util.List` | `getBusinessOperations()` List the currently defined business operations.
`java.util.List` | `getCallableWorkflows(java.lang.String orgID)` Return a List of workflows that can be called.
`ClassDescriptor` | `getClassDescriptor(java.lang.String className)` Get a server side class descriptor.
`java.util.List` | `getEventKeyInfo()` List the event keys defined within the workflow system.
`int` | `getInstanceCount(java.lang.String templateID)` Get a count of instances.
`int` | `getInstanceCount(java.lang.String templateID, boolean completed)` Get a count of instances.
`InstanceInfo` | `getInstanceInfo(java.lang.String instanceID)` Return information about the specified workflow instance.
`java.util.List` | `getInstanceTasks(java.lang.String instanceID)` List the tasks in a workflow instance.
`java.util.List` | `getInstanceVariables(java.lang.String instanceID)` List the variables in a workflow instance.
`java.lang.Object` | `getPluginInstanceData(java.lang.String pluginName, java.lang.String instanceID)` Retrieve the plugin-supplied data associated with a workflow instance.
`java.util.List` | `getReroutes(java.lang.String orgID)` List the task reroutes defined within an organization.
`int[]` | `getTaskCounts(java.lang.String assigneeID, java.lang.String orgID, boolean role)` Count the tasks assigned to a participant in an organization.
`java.util.List` | `getTasks(java.lang.String assigneeID, java.lang.String orgID, boolean role)` List the tasks assigned to a participant in an organization.
`java.util.List` | `getTasks(java.lang.String assigneeID, java.lang.String orgID, boolean role, boolean incompleteOnly, boolean sortAscending)` List the tasks assigned to a participant in an organization.
`TemplateInfo` | `getTemplate(java.lang.String templateID, boolean byName)` Return information about the specified workflow template.
`TemplateDefinitionInfo` | `getTemplateDefinition(java.lang.String templateDefinitionID)` Return the specified workflow template definition.
`java.lang.String` | `getTemplateDefinitionContent(java.lang.String definitionId)` Get the content of a workflow template definition.
`java.util.List` | `getTemplateDefinitionInstances(java.lang.String templateDefinitionID, java.lang.String orgID, boolean bStarted, java.util.Date from, java.util.Date to, int start, int max)` List the instances of a workflow template definition in an organization.
`java.util.List` | `getTemplateDefinitions(java.lang.String templateID)` List the definitions for a workflow template.
`java.util.List` | `getTemplateInstances(java.lang.String templateID, java.lang.String orgID, boolean bStarted, java.util.Date from, java.util.Date to, int start, int max)` List the instances of a workflow template in an organization.
`java.util.List` | `getTemplateOrgs(java.lang.String templateID)` List the organizations that have access to a workflow template.
`java.lang.String` | `getTemplateOwner(java.lang.String templateDefinitionID)` Get the current owner of a workflow template.
`java.util.List` | `getTemplates(java.lang.String orgID)` List the workflow templates for a specified organization.
`java.lang.String` | `importPackage(byte[] pkg, java.util.Map publishables, java.lang.String orgID, boolean activate, java.lang.Object credential)` Import a package of publishable workflow objects specified by publishables.
`void` | `lockTemplate(java.lang.String templateDefinitionID)` Place a persistent write lock on a workflow template.
`void` | `ping()` A "dummy" method for the client to ping at regular intervals.
`java.util.Map` | `readPackage(byte[] pkg, java.lang.Object credential)` Reads a packaged workflow application, as created by the `exportPackage(com.bea.wlpi.common.PublishPackage, java.lang.Object)` method.
`void` | `setInstanceVariable(java.lang.String templateDefinitionID, java.lang.String instanceID, java.lang.String variable, java.lang.Object value)` Assign a value to a workflow instance variable.
`void` | `setInstanceVariables(java.lang.String templateDefinitionID, java.lang.String instanceID, java.util.Map variables)` Assign values to workflow instance variables.
`void` | `setPluginInstanceData(java.lang.String pluginName, java.lang.String instanceID, java.lang.Object value)` Set the plugin-supplied data associated with a workflow instance.
`void` | `setTemplateDefinitionActive(java.lang.String templateDefinitionID, boolean bActivate)`
`void` | `setTemplateDefinitionContent(java.lang.String templateDefinitionID, java.lang.String xml)` Set the content of a workflow template definition.
`void` | `setTemplateNameOrgs(java.lang.String templateID, java.lang.String name, java.util.Collection orgs)` Deprecated. Use `setTemplateOrgs(java.lang.String, java.util.Collection)` and `updateTemplate(com.bea.wlpi.common.TemplateInfo)`.
`void` | `setTemplateOrgs(java.lang.String templateID, java.util.Collection orgs)` Specify which organizations have access to a workflow template.
`java.lang.String` | `statisticsQuery(java.lang.String xml)` Run a statistics query.
`void` | `taskAssign(java.lang.String templateDefinitionID, java.lang.String instanceID, java.lang.String taskID, java.lang.String assignTo, boolean bRole, boolean bLoadBalance)` Assign a task to a participant.
`void` | `taskMarkDone(java.lang.String templateDefinitionID, java.lang.String instanceID, java.lang.String taskID)` Mark a task as complete.
`void` | `taskSetProperties(java.lang.String templateDefinitionID, java.lang.String instanceID, java.lang.String taskID, int priority, boolean doneWithoutDoit, boolean doitIfDone, boolean unmarkDone, boolean modify, boolean reassign)` Set the properties for a task instance.
`void` | `taskUnassign(java.lang.String templateDefinitionID, java.lang.String instanceID, java.lang.String taskID)` Unassign a task.
`void` | `taskUnmarkDone(java.lang.String templateDefinitionID, java.lang.String instanceID, java.lang.String taskID)` Mark a task as incomplete.
`void` | `unlockTemplate(java.lang.String templateDefinitionID)` Unlock a previously locked template.
`void` | `updateBusinessCalendar(BusinessCalendarInfo calendarInfo)` Update a business calendar.
`void` | `updateBusinessOperation(java.lang.String busOpID, ClassInvocationDescriptor descriptor)` Update a business operation.
`void` | `updateBusinessOperation(java.lang.String busOpID, EJBInvocationDescriptor descriptor)` Update a business operation.
`void` | `updateEventKey(EventKeyInfo eventKeyInfo)` Update an event key.
`void` | `updateReroute(java.lang.String rerouteID, java.lang.String to, int type, java.sql.Timestamp effective, java.sql.Timestamp expiry)` Update a task reroute.
`void` | `updateReroute(java.lang.String rerouteID, java.lang.String from, java.lang.String to, int type, java.sql.Timestamp effective, java.sql.Timestamp expiry)` Update a task reroute.
`void` | `updateTemplate(TemplateInfo info)` Update a workflow template.
`java.lang.String` | `workloadQuery(java.lang.String xml)` Run a workload query.

Methods inherited from interface javax.ejb.EJBObject
`getEJBHome, getHandle, getPrimaryKey, isIdentical, remove`

Field Detail

### TASKCOUNT_TOTAL

    public static final int TASKCOUNT_TOTAL

  Count of all tasks assigned to user/role.
  See Also:
    `getTaskCounts`

### TASKCOUNT_PENDING

    public static final int TASKCOUNT_PENDING

  Count of tasks which have started but have not completed.
  See Also:
    `getTaskCounts`

### TASKCOUNT_INACTIVE

    public static final int TASKCOUNT_INACTIVE

  Count of tasks which have not started yet.
  See Also:
    `getTaskCounts`

### TASKCOUNT_COMPLETED

    public static final int TASKCOUNT_COMPLETED

  Count of tasks that have completed.
  See Also:
    `getTaskCounts`

### TASKCOUNT_OVERDUE

    public static final int TASKCOUNT_OVERDUE

  Count of tasks that have started and their due date has passed.
  See Also:
    `getTaskCounts`

Method Detail

### ping

    public void ping()
              throws java.rmi.RemoteException

  A "dummy" method for the client to ping at regular intervals. This is to circumvent the WebLogic Server session bean timeout. This method is idempotent.

  Throws:
    java.rmi.RemoteException - if a communications error occurred.

### createTemplate

    public java.lang.String createTemplate(java.lang.String name,
                                           java.util.Collection orgs)
                                    throws java.rmi.RemoteException,
                                           WorkflowException

  Deprecated. Use the new `createTemplate(String,String,Collection)` or `createTemplate(String,String,Collection,Object)`
  Create a workflow template with the specified name. This method is not idempotent.

  Parameters:
    `name` - The template name.
    `orgs` - IDs of organizations in which the template is accessible.
  Returns:
    The ID of the new template.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `createTemplateDefinition(java.lang.String, java.lang.String, java.lang.String)`, `getTemplates(java.lang.String)`, `setTemplateNameOrgs(java.lang.String, java.lang.String, java.util.Collection)`

### createTemplate

    public java.lang.String createTemplate(java.lang.String name,
                                           java.lang.String xml,
                                           java.util.Collection orgs)
                                    throws java.rmi.RemoteException,
                                           WorkflowException

  Create a workflow template with the specified name. This method is not idempotent.

  Parameters:
    `name` - The template name.
    `orgs` - IDs of organizations in which the template is accessible.
    `xml` - Plugin data in xml form.
  Returns:
    The ID of the new template.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `createTemplateDefinition(java.lang.String, java.lang.String, java.lang.String)`, `getTemplates(java.lang.String)`, `setTemplateNameOrgs(java.lang.String, java.lang.String, java.util.Collection)`

### createTemplate

    public java.lang.String createTemplate(java.lang.String name,
                                           java.lang.String xml,
                                           java.util.Collection orgs,
                                           java.lang.Object requestID)
                                    throws java.rmi.RemoteException,
                                           WorkflowException

  Create a workflow template with the specified name. This method is idempotent.

  Parameters:
    `name` - The template name.
    `orgs` - IDs of organizations in which the template is accessible.
    `xml` - Plugin data in xml form.
    `requestID` - The client request ID used to make the method idempotent.
  Returns:
    The ID of the new template.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Process Integrator 2.0
  See Also:
    `createTemplate(String,String,Collection)`

### getTemplate

    public TemplateInfo getTemplate(java.lang.String templateID,
                                    boolean byName)
                             throws java.rmi.RemoteException,
                                    WorkflowException

  Return information about the specified workflow template. This method is idempotent.

  Parameters:
    `templateID` - Name or ID of the template to retrieve.
    `byName` - If `true`, the `templateID` parameter is the template's name rather than its ID.
  Returns:
    The requested template object.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed. If the template does not exist, the message number is `Messages.TEMPLATE_NOT_FOUND`.
  Since:
    WebLogic Process Integrator 2.0
  See Also:
    `getTemplateDefinition(java.lang.String)`, `WorkflowException.getMessageNumber()`, `Messages`

### getTemplates

    public java.util.List getTemplates(java.lang.String orgID)
                                throws java.rmi.RemoteException,
                                       WorkflowException

  List the workflow templates for a specified organization. This method is idempotent.

  Parameters:
    `orgID` - ID of the organization for which to retrieve templates.
  Returns:
    A list of TemplateInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `createTemplate(java.lang.String, java.util.Collection)`

### setTemplateNameOrgs

    public void setTemplateNameOrgs(java.lang.String templateID,
                                    java.lang.String name,
                                    java.util.Collection orgs)
                             throws java.rmi.RemoteException,
                                    WorkflowException

  Deprecated. Use `setTemplateOrgs(java.lang.String, java.util.Collection)` and `updateTemplate(com.bea.wlpi.common.TemplateInfo)`.
  Specify which organizations have access to a workflow template. This method is idempotent.

  Parameters:
    `templateID` - ID of the template.
    `name` - The template name.
    `orgs` - Collection of organization IDs.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getTemplateOrgs(java.lang.String)`

### setTemplateOrgs

    public void setTemplateOrgs(java.lang.String templateID,
                                java.util.Collection orgs)
                         throws java.rmi.RemoteException,
                                WorkflowException

  Specify which organizations have access to a workflow template. This method is idempotent.

  Parameters:
    `templateID` - ID of the template.
    `orgs` - Collection of organization IDs.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Process Integrator 2.0
  See Also:
    `getTemplateOrgs(java.lang.String)`

### updateTemplate

    public void updateTemplate(TemplateInfo info)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Update a workflow template. This method is idempotent.

  Parameters:
    `info` - Template information.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Process Integrator 2.0
  See Also:
    `setTemplateOrgs(java.lang.String, java.util.Collection)`, `getTemplateOrgs(java.lang.String)`

### getTemplateOrgs

    public java.util.List getTemplateOrgs(java.lang.String templateID)
                                   throws java.rmi.RemoteException,
                                          WorkflowException

  List the organizations that have access to a workflow template. This method is idempotent.

  Parameters:
    `templateID` - ID of the template.
  Returns:
    A list of organization IDs.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `setTemplateNameOrgs(java.lang.String, java.lang.String, java.util.Collection)`

### checkForTemplateInstances

    public boolean checkForTemplateInstances(java.lang.String templateID)
                                      throws java.rmi.RemoteException,
                                             WorkflowException

  Check whether a workflow template has any started instances which are not yet complete. This method is idempotent.

  Parameters:
    `templateID` - ID of template for which to check instances.
  Returns:
    `true` - if uncompleted instances exist.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `checkForTemplateDefinitionInstances(java.lang.String)`

### findOldestTemplateInstance

    public java.sql.Timestamp findOldestTemplateInstance(java.lang.String templateID)
                                                  throws java.rmi.RemoteException,
                                                         WorkflowException

  Find the date and time of the oldest completed instance for this template.

  Parameters:
    `templateID` - ID of template for which to check instances.
  Returns:
    Timestamp of oldest completed instance Timestamp
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Integration 7.0 SP2

### getInstanceCount

    public int getInstanceCount(java.lang.String templateID)
                         throws java.rmi.RemoteException,
                                WorkflowException

  Get a count of instances. This method is idempotent.

  Parameters:
    `templateID` - ID of template for which to check instances.
  Returns:
    `int` - number of total instances
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getInstanceCount(String,boolean)`

### getInstanceCount

    public int getInstanceCount(java.lang.String templateID,
                                boolean completed)
                         throws java.rmi.RemoteException,
                                WorkflowException

  Get a count of instances. This method is idempotent.

  Parameters:
    `templateID` - ID of template for which to check instances.
    `completed` - if true, return count of completed instances. If false, return count of running instances
  Returns:
    `int` - number of completed or running instances
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getInstanceCount(String)`

### deleteTemplate

    public void deleteTemplate(java.lang.String templateID)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Delete a workflow template. This method also deletes all definitions and instances thereof. This method is idempotent.

  Parameters:
    `templateID` - ID of template to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `deleteTemplate(java.lang.String)`

### lockTemplate

    public void lockTemplate(java.lang.String templateDefinitionID)
                      throws java.rmi.RemoteException,
                             WorkflowException

  Place a persistent write lock on a workflow template. This method is idempotent.

  Parameters:
    `templateDefinitionID` - ID of template definition to lock.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `unlockTemplate(java.lang.String)`, `getTemplateOwner(java.lang.String)`

### unlockTemplate

    public void unlockTemplate(java.lang.String templateDefinitionID)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Unlock a previously locked template. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the template definition to unlock.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if the user submitting the request does not have a lock on the template or if an exception prevented the request from being completed
  See Also:
    `lockTemplate(java.lang.String)`, `getTemplateOwner(java.lang.String)`

### getTemplateOwner

    public java.lang.String getTemplateOwner(java.lang.String templateDefinitionID)
                                      throws java.rmi.RemoteException,
                                             WorkflowException

  Get the current owner of a workflow template. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the template definition for which to retrieve the owner.
  Returns:
    The The user ID of the current template owner.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `lockTemplate(java.lang.String)`, `unlockTemplate(java.lang.String)`

### createTemplateDefinition

    public java.lang.String createTemplateDefinition(java.lang.String templateID,
                                                     java.lang.String name,
                                                     java.lang.String xml)
                                              throws java.rmi.RemoteException,
                                                     WorkflowException

  Create a definition for a workflow template, using the name and content supplied. This method is not idempotent.

  Parameters:
    `templateID` - ID of the template in which to create the definition.
    `name` - Name for the new definition.
    `xml` - XML-format process definition.
  Returns:
    The ID of the new template definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `createTemplate(java.lang.String, java.util.Collection)`, `getTemplateDefinitions(java.lang.String)`, `setTemplateDefinitionContent(java.lang.String, java.lang.String)`

### createTemplateDefinition

    public java.lang.String createTemplateDefinition(java.lang.String templateId,
                                                     java.lang.String name,
                                                     java.lang.String xml,
                                                     java.lang.Object requestID)
                                              throws java.rmi.RemoteException,
                                                     WorkflowException

  Create a definition for a workflow template, using the name and content supplied. This method is idempotent.

  Parameters:
    `templateId` - ID of the template in which to create the definition.
    `name` - Name for the new definition.
    `xml` - XML-format process definition.
    `requestID` - The client request ID used to make the method idempotent.
  Returns:
    The ID of the new template definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Process Integrator 2.0
  See Also:
    `createTemplateDefinition(String,String,String)`

### getTemplateDefinition

    public TemplateDefinitionInfo getTemplateDefinition(java.lang.String templateDefinitionID)
                                                 throws java.rmi.RemoteException,
                                                        WorkflowException

  Return the specified workflow template definition. This method is idempotent.

  Parameters:
    `templateDefinitionID` - ID of the template definition to retrieve.
    `includeContent` - If `true`, includes the XML content of the template definition.
    `parsePluginData` - If `true`, parse the plugin-supplied template definition properties. This is necessary if the client wishes to call the `TemplateDefinitionInfo.getPluginData()` method on the result.
  Returns:
    The requested template definition object.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Process Integrator 2.0
  See Also:
    `getTemplate(java.lang.String, boolean)`

### getTemplateDefinitions

    public java.util.List getTemplateDefinitions(java.lang.String templateID)
                                          throws java.rmi.RemoteException,
                                                 WorkflowException

  List the definitions for a workflow template. This method is idempotent.

  Parameters:
    `templateID` - ID of the template for which to retrieve the definitions.
  Returns:
    A list of TemplateDefinitionInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `createTemplateDefinition(java.lang.String, java.lang.String, java.lang.String)`

### checkForTemplateDefinitionInstances

    public boolean checkForTemplateDefinitionInstances(java.lang.String templateDefinitionID)
                                                throws java.rmi.RemoteException,
                                                       WorkflowException

  Check whether the specified workflow template definition has any instances. This method is idempotent.

  Parameters:
    `templateDefinitionID` - ID of template definition to check.
  Returns:
    `true` - if instances exist.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `checkForTemplateInstances(java.lang.String)`

### setTemplateDefinitionContent

    public void setTemplateDefinitionContent(java.lang.String templateDefinitionID,
                                             java.lang.String xml)
                                      throws java.rmi.RemoteException,
                                             WorkflowException

  Set the content of a workflow template definition. The content (i.e., the business process definition) is expressed in XML format. This method is idempotent.

  Parameters:
    `templateDefinitionID` - ID of the template definition.
    `xml` - Process definition (in XML format) compliant with the workflow template document type definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `createTemplateDefinition(java.lang.String, java.lang.String, java.lang.String)`, `getTemplateDefinitionContent(java.lang.String)`

### getTemplateDefinitionContent

    public java.lang.String getTemplateDefinitionContent(java.lang.String definitionId)
                                                  throws java.rmi.RemoteException,
                                                         WorkflowException

  Get the content of a workflow template definition. The content (i.e., the business process definition) is expressed in XML format. This method is idempotent.

  Parameters:
    `templateDefinitionID` - ID of the template definition.
  Returns:
    Process definition (in XML format) compliant with the workflow template document type definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `setTemplateDefinitionContent(java.lang.String, java.lang.String)`

### deleteTemplateDefinition

    public void deleteTemplateDefinition(java.lang.String templateDefinitionID)
                                  throws java.rmi.RemoteException,
                                         WorkflowException

  Delete a workflow template definition. This method also deletes all instances thereof. This method is idempotent.

  Parameters:
    `templateDefinitionID` - ID of the template definition to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `deleteTemplateDefinition(java.lang.String)`

### getTemplateInstances

    public java.util.List getTemplateInstances(java.lang.String templateID,
                                               java.lang.String orgID,
                                               boolean bStarted,
                                               java.util.Date from,
                                               java.util.Date to,
                                               int start,
                                               int max)
                                        throws java.rmi.RemoteException,
                                               WorkflowException

  List the instances of a workflow template in an organization. This method is idempotent.

  Parameters:
    `templateID` - The ID of the template.
    `orgID` - The ID of the organization.
    `bStarted` - Whether to query by start or completion date. If `true`, the query uses the instance start date; otherwise, the completion date is used.
    `from` - Lower bound of date range to include.
    `to` - Upper bound of date range to include.
    `start` - Offset in results at which returned list starts. This enables clients to display long lists incrementally.
    `max` - Maximum number of items to return. This enables clients to limit the number of items to a subset of what could potentially be an extremely long list.
  Returns:
    A list of InstanceInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getTemplateDefinitionInstances(java.lang.String, java.lang.String, boolean, java.util.Date, java.util.Date, int, int)`

### getTemplateDefinitionInstances

    public java.util.List getTemplateDefinitionInstances(java.lang.String templateDefinitionID,
                                                         java.lang.String orgID,
                                                         boolean bStarted,
                                                         java.util.Date from,
                                                         java.util.Date to,
                                                         int start,
                                                         int max)
                                                  throws java.rmi.RemoteException,
                                                         WorkflowException

  List the instances of a workflow template definition in an organization. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the template definition.
    `orgID` - The ID of the organization.
    `bStarted` - Whether to query by start or completion date. If `true`, the query uses the instance start date; otherwise, the completion date is used.
    `from` - Lower bound of date range to include.
    `to` - Upper bound of date range to include.
    `start` - Offset in results at which returned list starts. This enables clients to display long lists incrementally.
    `max` - Maximum number of items to return. This enables clients to limit the number of items to a subset of what could potentially be an extremely long list.
  Returns:
    A list of InstanceInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getTemplateInstances(java.lang.String, java.lang.String, boolean, java.util.Date, java.util.Date, int, int)`

### getInstanceTasks

    public java.util.List getInstanceTasks(java.lang.String instanceID)
                                    throws java.rmi.RemoteException,
                                           WorkflowException

  List the tasks in a workflow instance. This method is idempotent.

  Parameters:
    `instanceID` - The ID of the workflow instance.
  Returns:
    A list of TaskInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getInstanceVariables(java.lang.String)`

### getInstanceVariables

    public java.util.List getInstanceVariables(java.lang.String instanceID)
                                        throws java.rmi.RemoteException,
                                               WorkflowException

  List the variables in a workflow instance. This method is idempotent.

  Parameters:
    `instanceID` - The ID of the workflow instance.
  Returns:
    A list of VariableInfo objects. The values of the variables are constrained according to their WebLogic Process Integrator variable types:

    WLPI Type | Java Class/Interface
    --- | ---
    boolean | `java.lang.Boolean`
    date | `java.lang.Date`
    double | `java.lang.Double`
    entity EJB | `javax.ejb.Handle`
    integer | `java.lang.Integer` or `java.lang.Long`. In versions of WebLogic Process Integrator prior to 2.0, integer type variables are stored as `java.lang.Integer` objects. WebLogic Process Integrator 2.0 stores new instances of such values using `java.lang.Long` objects. Existing instances may assign either `java.lang.Integer` or `java.lang.Long` values to their integer type variables, depending on the actual expression that was evaluated to generate the new value. A reference to an existing integer variable instance (e.g., $MyExistingIntVariable) that has not yet been updated under WebLogic Process Integrator 2.0 will return a `java.lang.Integer` object, whereas an expression such as (4 + 5 * $MyExistingIntVariable) will return a `java.lang.Long` object. Existing client programs that call this method and currently cast the result java.lang.Integer will need to be modified to test the value of an integer object and cast it either to `java.lang.Integer` or `java.lang.Long` as appropriate. Note that this incompatibility is not apparent until runtime: existing source code will continue to build without problems. The `setInstanceVariable(java.lang.String, java.lang.String, java.lang.String, java.lang.Object)` method expects to receive a `java.lang.Long` object.
    object | `java.lang.Serializable`
    session EJB | `javax.ejb.Handle`
    string | `java.lang.String`
    plugin types | `java.lang.Serializable`
    xml | `byte[]`: this is the XML document text, encoded in UTF-8. Applications can either construct a `java.lang.String`, or a `java.io.ByteArrayInputStream` object on the byte array, depending on how they wish to use the XML document. Clients wishing to perform a DOM parse will need to specify an entity resolver if the XML document contains a DOCTYPE or other entity references. They can use `com.bea.eci.repository.helper.RepositoryResolver` if they wish to obtain the same resolution behavior as occurs in the Studio and server; which is, entities are resolved against the XML repository.

  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `setInstanceVariable(java.lang.String, java.lang.String, java.lang.String, java.lang.Object)`, `getInstanceTasks(java.lang.String)`

### setInstanceVariable

    public void setInstanceVariable(java.lang.String templateDefinitionID,
                                    java.lang.String instanceID,
                                    java.lang.String variable,
                                    java.lang.Object value)
                             throws java.rmi.RemoteException,
                                    WorkflowException

  Assign a value to a workflow instance variable. The following conversions are supported for the `value` parameter:

  Variable Type | Value Class | Notes
  --- | --- | ---
  Boolean | `java.lang.Boolean, java.lang.Number, java.lang.String, org.w3c.dom.Node, org.w3c.dom.NodeList` | Numbers are treated as `true` if non-zero. Strings are treated as `true` if they have the value "true". The same treatment is applied to the node value of `Node` and the first item of a `NodeList`. Any other value class throws an exception.
  Date | `java.util.Date` | Strings are converted to dates using `VariableInfo.DEFAULT_DATE_FORMAT`
  Double | `java.lang.Number, java.lang.Boolean, java.lang.String, org.w3c.dom.Node, org.w3c.dom.NodeList` | Numbers simply yield their `doubleValue()`. Boolean `true` yields `1.0`, `false` yields `0.0`. Strings must contain a valid string representation of a double constant. The same treatment is applied to the node value of `Node` and the first item of a `NodeList`. Any other value class throws an exception.
  Entity EJB | `javax.ejb.Handle` | The system checks the value to ensure that it is a handle for an entity EJB, then stores the handle. Any other value class throws an exception.
  Integer | `java.lang.Number, java.lang.Boolean, java.lang.String, org.w3c.dom.Node, org.w3c.dom.NodeList` | Numbers simply yield their `intValue()`. Boolean `true` yields `1`, `false` yields `0`. Strings must contain a valid string representation of an integer constant. The same treatment is applied to the node value of `Node` and the first item of a `NodeList`. Any other value class throws an exception.
  Object | `java.lang.Object` | Any serializable Java object can be stored.
  <Plugin> | `java.lang.Object` | The value must be assignable to the value class defined by the plugin for this variable type. Any other value class throws an exception.
  Session EJB | `javax.ejb.Handle` | The system checks the value to ensure that it is a handle for a session EJB, then stores the handle. Any other value class throws an exception.
  String | `org.w3c.dom.Node, org.w3c.dom.NodeList, java.lang.Object` | All object types yield their string representation. The same treatment is applied to the node value of `Node` and the first item of a `NodeList`.
  XML | `org.w3c.dom.Node, org.w3c.dom.NodeList, java.lang.String, byte[]` | The system performs a non-validating SAX parse on string values to ensure that they contain valid XML markup, then converts the string to a UTF-8 encoded byte array. A DOM `Node` and the first item of a `NodeList` object is serialized to a UTF-8 encoded byte array. A `byte[]` value is assumed to be a UTF-8 encoded string containing a valid XML document. The value is not parsed or verified. Any other value class throws an exception.

  This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `variable` - Name of the variable to set.
    `value` - The new value to assign, which must be compatible with the variable's declared type, as described in the above table.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getInstanceVariables(java.lang.String)`

### setInstanceVariables

    public void setInstanceVariables(java.lang.String templateDefinitionID,
                                     java.lang.String instanceID,
                                     java.util.Map variables)
                              throws java.rmi.RemoteException,
                                     WorkflowException

  Assign values to workflow instance variables.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `variables` - Map containing variable names as the key and value objects
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getInstanceVariables(java.lang.String)`

### getPluginInstanceData

    public java.lang.Object getPluginInstanceData(java.lang.String pluginName,
                                                  java.lang.String instanceID)
                                           throws java.rmi.RemoteException,
                                                  WorkflowException

  Retrieve the plugin-supplied data associated with a workflow instance. This method is idempotent.

  Parameters:
    `pluginName` - The reverse-DNS name of the plugin.
    `instanceID` - The ID of the workflow instance.
  Returns:
    The plugin-supplied instance data.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `setPluginInstanceData(java.lang.String, java.lang.String, java.lang.Object)`

### setPluginInstanceData

    public void setPluginInstanceData(java.lang.String pluginName,
                                      java.lang.String instanceID,
                                      java.lang.Object value)
                               throws java.rmi.RemoteException,
                                      WorkflowException

  Set the plugin-supplied data associated with a workflow instance. This method is idempotent.

  Parameters:
    `pluginName` - The reverse-DNS name of the plugin.
    `instanceID` - The ID of the workflow instance.
    `value` - The value to store.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getPluginInstanceData(java.lang.String, java.lang.String)`

### deleteInstance

    public void deleteInstance(java.lang.String instanceID)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Delete a workflow instance. This method is idempotent.

  Parameters:
    `instanceID` - The ID of the workflow instance to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `deleteTemplateInstances(java.lang.String, java.lang.String, boolean, java.util.Date, java.util.Date)`, `deleteTemplateDefinitionInstances(java.lang.String, java.lang.String, boolean, java.util.Date, java.util.Date)`

### deleteTemplateInstances

    public void deleteTemplateInstances(java.lang.String templateID,
                                        java.lang.String orgID,
                                        boolean bStarted,
                                        java.util.Date from,
                                        java.util.Date to)
                                 throws java.rmi.RemoteException,
                                        WorkflowException

  Delete instances of a workflow template in an organization. This method is idempotent.

  Parameters:
    `templateID` - The ID of the workflow template for which to delete instances.
    `orgID` - The ID of the organization for which to delete instances.
    `bStarted` - Whether to delete by start or completion date. If `true`, the query uses the instance start date; otherwise, the completion date is used.
    `from` - Lower bound of date range to include.
    `to` - Upper bound of date range to include.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `deleteInstance(java.lang.String)`, `deleteTemplateDefinitionInstances(java.lang.String, java.lang.String, boolean, java.util.Date, java.util.Date)`

### deleteTemplateDefinitionInstances

    public void deleteTemplateDefinitionInstances(java.lang.String templateDefinitionID,
                                                  java.lang.String orgID,
                                                  boolean bStarted,
                                                  java.util.Date from,
                                                  java.util.Date to)
                                           throws java.rmi.RemoteException,
                                                  WorkflowException

  Delete instances of a workflow template definition in an organization. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition for which to delete instances.
    `orgID` - The ID of the organization for which to delete instances.
    `bStarted` - Whether to delete by start or completion date. If `true`, the query uses the instance start date; otherwise, the completion date is used.
    `from` - Lower bound of date range to include.
    `to` - Upper bound of date range to include.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `deleteInstance(java.lang.String)`, `deleteTemplateInstances(java.lang.String, java.lang.String, boolean, java.util.Date, java.util.Date)`

### getTasks

    public java.util.List getTasks(java.lang.String assigneeID,
                                   java.lang.String orgID,
                                   boolean role)
                            throws java.rmi.RemoteException,
                                   WorkflowException

  List the tasks assigned to a participant in an organization. This method is idempotent.

  Parameters:
    `assigneeId` - The ID of the assignee for which to list tasks.
    `orgID` - The ID of the organization.
    `role` - `true` if the assignee is a role, `false` if a user.
  Returns:
    A list of TaskInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.

### getTasks

    public java.util.List getTasks(java.lang.String assigneeID,
                                   java.lang.String orgID,
                                   boolean role,
                                   boolean incompleteOnly,
                                   boolean sortAscending)
                            throws java.rmi.RemoteException,
                                   WorkflowException

  List the tasks assigned to a participant in an organization.

  Parameters:
    `assigneeID` - The ID of the assignee for which to list tasks.
    `orgID` - The ID of the organization.
    `role` - `true` if the assignee is a role, `false` if a user.
    `incompleteOnly` - `true` to return only tasks that have not completed, `false` to return all tasks.
    `sortAscending` - `true` to sort tasks in ascending time/date started order, `false` to sort in descending order.
  Returns:
    A list of TaskInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.

### getTaskCounts

    public int[] getTaskCounts(java.lang.String assigneeID,
                               java.lang.String orgID,
                               boolean role)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Count the tasks assigned to a participant in an organization.

  Parameters:
    `assigneeID` - The ID of the assignee for which to count tasks.
    `orgID` - The ID of the organization.
    `role` - `true` if the assignee is a role, `false` if a user.
  Returns:
    An array of task counts as follows:

    `element[TASKCOUNT_TOTAL]` | the total number of tasks assigned to the user/role.
    `element[TASKCOUNT_PENDING]` | the number of those tasks which are pending.
    `element[TASKCOUNT_INACTIVE]` | the number of those tasks which are inactive.
    `element[TASKCOUNT_COMPLETED]` | the number of those tasks which are completed.
    `element[TASKCOUNT_OVERDUE]` | the number of those tasks which are overdue.

  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `TASKCOUNT_TOTAL`, `TASKCOUNT_PENDING`, `TASKCOUNT_INACTIVE`, `TASKCOUNT_COMPLETED`, `TASKCOUNT_OVERDUE`

### taskMarkDone

    public void taskMarkDone(java.lang.String templateDefinitionID,
                             java.lang.String instanceID,
                             java.lang.String taskID)
                      throws java.rmi.RemoteException,
                             WorkflowException

  Mark a task as complete. Calling this method results in the task's "completed" date being set to the current time and in the execution of any actions defined for the task's "completed" event. This method is not idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `taskID` - The ID of the task instance.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if the method is called by a client process and the task's properties do not permit it to be marked complete or if an exception prevented the request from being completed.
  See Also:
    `taskUnmarkDone(java.lang.String, java.lang.String, java.lang.String)`

### taskUnmarkDone

    public void taskUnmarkDone(java.lang.String templateDefinitionID,
                               java.lang.String instanceID,
                               java.lang.String taskID)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Mark a task as incomplete. The default implementation clears the task's "completed" date but does not cause the execution of the actions defined for the task's "started" event. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `taskID` - The ID of the task instance.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if the method is called by a client process and the task's properties do not permit it to be marked incomplete or if an exception prevented the request from being completed.
  See Also:
    `taskMarkDone(java.lang.String, java.lang.String, java.lang.String)`

### taskAssign

    public void taskAssign(java.lang.String templateDefinitionID,
                           java.lang.String instanceID,
                           java.lang.String taskID,
                           java.lang.String assignTo,
                           boolean bRole,
                           boolean bLoadBalance)
                    throws java.rmi.RemoteException,
                           WorkflowException

  Assign a task to a participant. The actual participant to whom the system assigns the task depends on: 1.) whether any task reroutes are currently in force for the nominated assignee and 2.) the value of the `bLoadBalance` argument. This method is not idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `taskID` - The ID of the task instance.
    `assigneeId` - The ID of the participant to whom the task is to be assigned.
    `bRole` - `true` if the assignee ID is that of a role, `false` if that of a user.
    `bLoadBalance` - `true` to request the system to perform load-balancing within the specified role. This argument is ignored if the `bRole` argument is `false`.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if the method is called by a client process and the task's properties do not permit it to be reassigned or if an exception prevented the request from being completed.

### taskUnassign

    public void taskUnassign(java.lang.String templateDefinitionID,
                             java.lang.String instanceID,
                             java.lang.String taskID)
                      throws java.rmi.RemoteException,
                             WorkflowException

  Unassign a task. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `taskID` - The ID of the task instance.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if the method is called by a client process and the task's properties do not permit it to be reassigned or if an exception prevented the request from being completed.

### taskSetProperties

    public void taskSetProperties(java.lang.String templateDefinitionID,
                                  java.lang.String instanceID,
                                  java.lang.String taskID,
                                  int priority,
                                  boolean doneWithoutDoit,
                                  boolean doitIfDone,
                                  boolean unmarkDone,
                                  boolean modify,
                                  boolean reassign)
                           throws java.rmi.RemoteException,
                                  WorkflowException

  Set the properties for a task instance. This method is idempotent.

  Parameters:
    `templateDefinitionID` - The ID of the workflow template definition.
    `instanceID` - The ID of the workflow instance.
    `taskID` - The ID of the task instance.
    `priority` - Default task instance priority (0=low, 1=medium or 2=high).
    `doneWithoutDoit` - `true` to permit a user to mark a task instance as complete (by calling the `taskMarkDone(java.lang.String, java.lang.String, java.lang.String)` method).
    `doitIfDone` - `true` to permit a user to execute a task instance after it has been marked as complete.
    `unmarkDone` - `true` to permit a user to mark a task instance as incomplete (by calling the `taskUnmarkDone(java.lang.String, java.lang.String, java.lang.String)` method).
    `modify` - `true` to permit a user to modify a task instance's runtime properties (by calling this method).
    `reassign` - `true` to permit a user to reassign a task instance to another participant (by calling the `taskAssign(java.lang.String, java.lang.String, java.lang.String, java.lang.String, boolean, boolean)` method).
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if the mthod is called by a client process and the task's properties do not permit it to be modified or if an exception prevented the request from being completed

### getBusinessOperations

    public java.util.List getBusinessOperations()
                                         throws java.rmi.RemoteException,
                                                WorkflowException

  List the currently defined business operations. This method is idempotent.

  Returns:
    A heterogenous list of ClassInvocationDescriptor or EJBInvocationDescriptor objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.

### getClassDescriptor

    public ClassDescriptor getClassDescriptor(java.lang.String className)
                                       throws java.rmi.RemoteException,
                                              WorkflowException

  Get a server side class descriptor. This method is idempotent.

  Parameters:
    `className` - Fully qualified Java class name for which to return a descriptor.
  Returns:
    Meta-data for the specified class.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.

### addBusinessOperation

    public java.lang.String addBusinessOperation(ClassInvocationDescriptor descriptor)
                                          throws java.rmi.RemoteException,
                                                 WorkflowException

  Create a new business operation implemented by a Java class. This method is not idempotent.

  Parameters:
    `descriptor` - Meta-data describing method invocation on the underlying Java class that implements the business operation.
  Returns:
    The ID of the new business operation.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `updateBusinessOperation(String, ClassInvocationDescriptor)`, `deleteBusinessOperation(String)`

### updateBusinessOperation

    public void updateBusinessOperation(java.lang.String busOpID,
                                        ClassInvocationDescriptor descriptor)
                                 throws java.rmi.RemoteException,
                                        WorkflowException

  Update a business operation. This method is idempotent.

  Parameters:
    `busOpID` - The ID of the business operation to update.
    `descriptor` - Meta-data describing method invocation on the underlying Java class that implements the business operation.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addBusinessOperation(ClassInvocationDescriptor)`, `deleteBusinessOperation(String)`

### addBusinessOperation

    public java.lang.String addBusinessOperation(EJBInvocationDescriptor descriptor)
                                          throws java.rmi.RemoteException,
                                                 WorkflowException

  Create a new business operation implemented by an EJB. This method is not idempotent.

  Parameters:
    `descriptor` - Meta-data describing method invocation on the underlying EJB that implements the business operation.
  Returns:
    The ID of the new business operation.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `updateBusinessOperation(String, EJBInvocationDescriptor)`, `deleteBusinessOperation(String)`

### updateBusinessOperation

    public void updateBusinessOperation(java.lang.String busOpID,
                                        EJBInvocationDescriptor descriptor)
                                 throws java.rmi.RemoteException,
                                        WorkflowException

  Update a business operation. This method is idempotent.

  Parameters:
    `busOpID` - The ID of the business operation to update.
    `descriptor` - Meta-data describing method invocation on the underlying EJB that implements the business operation.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addBusinessOperation(EJBInvocationDescriptor)`, `deleteBusinessOperation(String)`

### deleteBusinessOperation

    public void deleteBusinessOperation(java.lang.String busOpID)
                                 throws java.rmi.RemoteException,
                                        WorkflowException

  Delete a business operation. This method is idempotent.

  Parameters:
    `busOpID` - The ID of the business operation to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addBusinessOperation(EJBInvocationDescriptor)`, `addBusinessOperation(ClassInvocationDescriptor)`

### getReroutes

    public java.util.List getReroutes(java.lang.String orgID)
                               throws java.rmi.RemoteException,
                                      WorkflowException

  List the task reroutes defined within an organization. This method is idempotent.

  Parameters:
    `orgID` - The ID of the organization for which to list reroutes.
  Returns:
    A list of RerouteInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.

### addReroute

    public java.lang.String addReroute(java.lang.String orgID,
                                       java.lang.String from,
                                       java.lang.String to,
                                       int type,
                                       java.sql.Timestamp effective,
                                       java.sql.Timestamp expiry)
                                throws java.rmi.RemoteException,
                                       WorkflowException

  Create a new task reroute. This method is not idempotent.

  Parameters:
    `orgID` - The ID of the organization to which reroute applies.
    `from` - The ID of the assignee whose tasks are to be rerouted.
    `to` - The ID of the participant to whom the rerouted tasks will be assigned.
    `type` - Type of reroute: TYPE_USER, TYPE_USERINROLE or TYPE_ROLE
    `effective` - Date/time at which reroute becomes effective.
    `expiry` - Date/time at which reroute ceases to be effective.
  Returns:
    The ID of the new Reroute object.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `updateReroute(java.lang.String, java.lang.String, int, java.sql.Timestamp, java.sql.Timestamp)`, `deleteReroute(java.lang.String)`

### updateReroute

    public void updateReroute(java.lang.String rerouteID,
                              java.lang.String to,
                              int type,
                              java.sql.Timestamp effective,
                              java.sql.Timestamp expiry)
                       throws java.rmi.RemoteException,
                              WorkflowException

  Update a task reroute. This method is idempotent.

  Parameters:
    `rerouteID` - The ID of the reroute to update.
    `to` - The ID of the participant to whom the rerouted tasks will be assigned.
    `type` - Type of reroute: TYPE_USER, TYPE_USERINROLE or TYPE_ROLE
    `effective` - Date/time at which reroute becomes effective.
    `expiry` - Date/time at which reroute ceases to be effective.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addReroute(java.lang.String, java.lang.String, java.lang.String, int, java.sql.Timestamp, java.sql.Timestamp)`, `deleteReroute(java.lang.String)`

### updateReroute

    public void updateReroute(java.lang.String rerouteID,
                              java.lang.String from,
                              java.lang.String to,
                              int type,
                              java.sql.Timestamp effective,
                              java.sql.Timestamp expiry)
                       throws java.rmi.RemoteException,
                              WorkflowException

  Update a task reroute. This method is idempotent.

  Parameters:
    `rerouteID` - The ID of the reroute to update.
    `from` - The ID of the participant from whom the rerouted tasks will be reassigned.
    `to` - The ID of the participant to whom the rerouted tasks will be assigned.
    `type` - Type of reroute: TYPE_USER, TYPE_USERINROLE or TYPE_ROLE
    `effective` - Date/time at which reroute becomes effective.
    `expiry` - Date/time at which reroute ceases to be effective.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    WebLogic Process Integrator version 1.2.
  See Also:
    `addReroute(java.lang.String, java.lang.String, java.lang.String, int, java.sql.Timestamp, java.sql.Timestamp)`, `deleteReroute(java.lang.String)`

### deleteReroute

    public void deleteReroute(java.lang.String rerouteID)
                       throws java.rmi.RemoteException,
                              WorkflowException

  Delete a task reroute. This method is idempotent.

  Parameters:
    `rerouteID` - The ID of the reroute to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addReroute(java.lang.String, java.lang.String, java.lang.String, int, java.sql.Timestamp, java.sql.Timestamp)`, `updateReroute(java.lang.String, java.lang.String, int, java.sql.Timestamp, java.sql.Timestamp)`

### getEventKeyInfo

    public java.util.List getEventKeyInfo()
                                   throws java.rmi.RemoteException,
                                          WorkflowException

  List the event keys defined within the workflow system. This method is idempotent.

  Returns:
    A list of EventKeyInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.

### addEventKey

    public void addEventKey(EventKeyInfo eventKeyInfo)
                     throws java.rmi.RemoteException,
                            WorkflowException

  Create a new event key. This method is not idempotent.

  Parameters:
    `eventKeyInfo` - Values for the new event key.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `updateEventKey(com.bea.wlpi.common.EventKeyInfo)`, `deleteEventKey(com.bea.wlpi.common.EventKeyInfo)`

### updateEventKey

    public void updateEventKey(EventKeyInfo eventKeyInfo)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Update an event key. This method is idempotent.

  Parameters:
    `eventKeyInfo` - Updated values for the event key.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addEventKey(com.bea.wlpi.common.EventKeyInfo)`, `deleteEventKey(com.bea.wlpi.common.EventKeyInfo)`

### deleteEventKey

    public void deleteEventKey(EventKeyInfo eventKeyInfo)
                        throws java.rmi.RemoteException,
                               WorkflowException

  Delete an event key. This method is idempotent.

  Parameters:
    `eventKeyInfo` - The event key to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addEventKey(com.bea.wlpi.common.EventKeyInfo)`, `updateEventKey(com.bea.wlpi.common.EventKeyInfo)`

### workloadQuery

    public java.lang.String workloadQuery(java.lang.String xml)
                                   throws java.rmi.RemoteException,
                                          WorkflowException

  Run a workload query. This method is idempotent.

  Parameters:
    `xml` - The query specification, which must conform to the workload query document type definition.
  Returns:
    The workload report (in XML format) compliant with the workload report document type definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `statisticsQuery(java.lang.String)`

### statisticsQuery

    public java.lang.String statisticsQuery(java.lang.String xml)
                                     throws java.rmi.RemoteException,
                                            WorkflowException

  Run a statistics query. This method is idempotent.

  Parameters:
    `xml` - The query specification, which must conform to the statistics query document type definition.
  Returns:
    The statistics report (in XML format) compliant with the statistics report document type definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `workloadQuery(java.lang.String)`

### getAllBusinessCalendars

    public java.util.List getAllBusinessCalendars(boolean includeDefinition)
                                           throws java.rmi.RemoteException,
                                                  WorkflowException

  List the business calendars defined in the workflow system. This method is idempotent.

  Parameters:
    `includeDefinition` - `true` to include the XML calendar specification in the returned objects.
  Returns:
    A list of BusinessCalendarInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getBusinessCalendarDefinition(java.lang.String)`

### addBusinessCalendar

    public java.lang.String addBusinessCalendar(BusinessCalendarInfo calendarInfo)
                                         throws java.rmi.RemoteException,
                                                WorkflowException

  Create a new business calendar. This method is not idempotent.

  Parameters:
    `calendarInfo` - Values for the new business calendar.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `updateBusinessCalendar(com.bea.wlpi.common.BusinessCalendarInfo)`, `deleteBusinessCalendar(java.lang.String)`

### updateBusinessCalendar

    public void updateBusinessCalendar(BusinessCalendarInfo calendarInfo)
                                throws java.rmi.RemoteException,
                                       WorkflowException

  Update a business calendar. This method is idempotent.

  Parameters:
    `calendarInfo` - Updated values for the business calendar.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addBusinessCalendar(com.bea.wlpi.common.BusinessCalendarInfo)`, `deleteBusinessCalendar(java.lang.String)`

### deleteBusinessCalendar

    public void deleteBusinessCalendar(java.lang.String calendarID)
                                throws java.rmi.RemoteException,
                                       WorkflowException

  Delete a business calendar. This method is idempotent.

  Parameters:
    `calendarID` - The ID of the business calendar to delete.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `addBusinessCalendar(com.bea.wlpi.common.BusinessCalendarInfo)`, `updateBusinessCalendar(com.bea.wlpi.common.BusinessCalendarInfo)`

### getBusinessCalendarDefinition

    public java.lang.String getBusinessCalendarDefinition(java.lang.String calendarID)
                                                   throws java.rmi.RemoteException,
                                                          WorkflowException

  Return the definition of a business calendar. This method is idempotent.

  Parameters:
    `calendarID` - The ID of the business calendar for which definition is required.
  Returns:
    The business calendar definition (in XML format) compliant with the business calendar document type definition.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  See Also:
    `getAllBusinessCalendars(boolean)`

### getCallableWorkflows

    public java.util.List getCallableWorkflows(java.lang.String orgID)
                                        throws java.rmi.RemoteException,
                                               WorkflowException

  Return a List of workflows that can be called. This method is idempotent.

  Parameters:
    `orgID` - The ID of the organization for which to list workflows.
  Returns:
    A list of TemplateInfo objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the call from completing.
  Since:
    WebLogic Process Integrator version 1.2.

### findCallableWorkflow

    public java.lang.String findCallableWorkflow(java.lang.String templateName,
                                                 java.lang.String templateID,
                                                 java.lang.String orgID)
                                          throws java.rmi.RemoteException,
                                                 WorkflowException

  Return the most appropriate (active and effective) callable workflow template.

  Parameters:
    `templateName` - name of the template to retrieve definitions from.
    `templateID` - ID of the template to retrieve definitions from.
    `orgID` - The ID of the organization.
  Returns:
    The requested template definition object.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the request from being completed.
  Since:
    Weblogic Integration 7.0

### readPackage

    public java.util.Map readPackage(byte[] pkg,
                                     java.lang.Object credential)
                              throws java.rmi.RemoteException,
                                     WorkflowException

  Reads a packaged workflow application, as created by the `exportPackage(com.bea.wlpi.common.PublishPackage, java.lang.Object)` method. This method can be called by design-time clients in order to display the contents of the package, to enable users to select the objects they wish to import. This method is idempotent.

  Parameters:
    `pkg` - A byte array which is the image of a JAR file containing the exported objects.
    `credential` - An object containing the password if the package is password protected, `null` otherwise.
  Returns:
    A map of the objects in the package, keyed on the constants defined in the `Publishable` interface. The values in the map are hetereogenous `java.util.List` objects containing `XxxInfo` objects of a type to match the corresponding key:

    Key | List element type
    --- | ---
    `PublishableConstants.TEMPLATE` | `TemplateInfo`
    `PublishableConstants.TEMPLATE_DEFINITION` | `TemplateDefinitionInfo`
    `PublishableConstants.BUSINESS_OPERATION` | `ClassInvocationDescriptor` or `EJBInvocationDescriptor`
    `PublishableConstants.BUSINESS_CALENDAR` | `BusinessCalendarInfo`
    `PublishableConstants.USER` | `UserInfo`
    `PublishableConstants.ROLE` | `RoleInfo`
    `PublishableConstants.ORG` | `OrganizationInfo`
    `PublishableConstants.XML_REPOSITORY_FOLDER` | `RepositoryFolderInfoHelper`
    `PublishableConstants.XML_REPOSITORY_ENTITY` | `XMLEntityInfoHelper`
    `PublishableConstants.EVENT_KEY` | `EventKeyInfo`

  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the call from completing or if the password is incorrect.
  Since:
    WebLogic Process Integrator 2.0

### importPackage

    public java.lang.String importPackage(byte[] pkg,
                                          java.util.Map publishables,
                                          java.lang.String orgID,
                                          boolean activate,
                                          java.lang.Object credential)
                                   throws java.rmi.RemoteException,
                                          WorkflowException

  Import a package of publishable workflow objects specified by publishables. This method is idempotent.

  Parameters:
    `pkg` - A byte array which is the image of a JAR file containing all exported objects.
    `publishables` - A Map with the following structure:

    Map keys | Publishable types as defined in com.bea.wlpi.common.Publishable.
    Map values | List of Objects of type com.bea.wlpi.common.PackageEntry

    `orgID` - The ID of the organization to which the package is being imported.
    `activate` - indicates whether the imported workflows should be activated on import or not.
    `credential` - An object containing the password if the package is password protected, null otherwise.
  Returns:
    A String containing a report about any issues such as unresolved references.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the call from completing or if the password is incorrect.
  Since:
    WebLogic Process Integrator 2.0

### exportPackage

    public byte[] exportPackage(PublishPackage publishPackage,
                                java.lang.Object credential)
                         throws java.rmi.RemoteException,
                                WorkflowException

  Exports a package of workflow objects specified by publishPackage. This method is idempotent.

  Parameters:
    `publishPackage` - An object of type com.bea.wlpi.common.PublishPackage, which contains the entries of type com.bea.wlpi.common.PackageEntry to be exported into the Jar package.
    `credential` - An object containing the password if the package is password protected, null otherwise.
  Returns:
    A byte array which is the image of a JAR file containing all exported objects.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the call from completing.
  Since:
    WebLogic Process Integrator 2.0

### getInstanceInfo

    public InstanceInfo getInstanceInfo(java.lang.String instanceID)
                                 throws java.rmi.RemoteException,
                                        WorkflowException

  Return information about the specified workflow instance. This method is idempotent.

  Parameters:
    `instanceID` - The ID of the workflow instance.
  Returns:
    Information about the specified instance.
  Throws:
    java.rmi.RemoteException - if a communications error occurred.
    WorkflowException - if an exception prevented the call from completing.
  Since:
    WebLogic Process Integrator 2.1 SP1

### setTemplateDefinitionActive

    public void setTemplateDefinitionActive(java.lang.String templateDefinitionID,
                                            boolean bActivate)
                                     throws java.rmi.RemoteException,
                                            WorkflowException

  Parameters:
    `orgId` - the organization id that is searched for workflows referenced by the action start workflow.
    `templateDefinitionID` - The ID of the workflow template definition that will be activated or deactivated.
    `bActivate` - indicates whether the workflow template definition should be activated (`true`) or deactivated (`false`).

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| WebLogic Integration
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

WebLogic Integration (WLI)